<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDealDetail ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDealDetail
 * @subpackage Arrays
 */
class ArrayOfDealDetail extends AbstractStructArrayBase
{
    /**
     * The DealDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DealDetail[]
     */
    public $DealDetail;
    /**
     * Constructor method for ArrayOfDealDetail
     * @uses ArrayOfDealDetail::setDealDetail()
     * @param \StructType\DealDetail[] $dealDetail
     */
    public function __construct(array $dealDetail = array())
    {
        $this
            ->setDealDetail($dealDetail);
    }
    /**
     * Get DealDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DealDetail[]|null
     */
    public function getDealDetail()
    {
        return isset($this->DealDetail) ? $this->DealDetail : null;
    }
    /**
     * Set DealDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DealDetail[] $dealDetail
     * @return \ArrayType\ArrayOfDealDetail
     */
    public function setDealDetail(array $dealDetail = array())
    {
        foreach ($dealDetail as $arrayOfDealDetailDealDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfDealDetailDealDetailItem instanceof \StructType\DealDetail) {
                throw new \InvalidArgumentException(sprintf('The DealDetail property can only contain items of \StructType\DealDetail, "%s" given', is_object($arrayOfDealDetailDealDetailItem) ? get_class($arrayOfDealDetailDealDetailItem) : gettype($arrayOfDealDetailDealDetailItem)), __LINE__);
            }
        }
        if (is_null($dealDetail) || (is_array($dealDetail) && empty($dealDetail))) {
            unset($this->DealDetail);
        } else {
            $this->DealDetail = $dealDetail;
        }
        return $this;
    }
    /**
     * Add item to DealDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\DealDetail $item
     * @return \ArrayType\ArrayOfDealDetail
     */
    public function addToDealDetail(\StructType\DealDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DealDetail) {
            throw new \InvalidArgumentException(sprintf('The DealDetail property can only contain items of \StructType\DealDetail, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DealDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DealDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DealDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DealDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DealDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DealDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DealDetail
     */
    public function getAttributeName()
    {
        return 'DealDetail';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDealDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
