<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDealDetails ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDealDetails
 * @subpackage Arrays
 */
class ArrayOfDealDetails extends AbstractStructArrayBase
{
    /**
     * The DealDetails
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DealDetails[]
     */
    public $DealDetails;
    /**
     * Constructor method for ArrayOfDealDetails
     * @uses ArrayOfDealDetails::setDealDetails()
     * @param \StructType\DealDetails[] $dealDetails
     */
    public function __construct(array $dealDetails = array())
    {
        $this
            ->setDealDetails($dealDetails);
    }
    /**
     * Get DealDetails value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DealDetails[]|null
     */
    public function getDealDetails()
    {
        return isset($this->DealDetails) ? $this->DealDetails : null;
    }
    /**
     * Set DealDetails value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DealDetails[] $dealDetails
     * @return \ArrayType\ArrayOfDealDetails
     */
    public function setDealDetails(array $dealDetails = array())
    {
        foreach ($dealDetails as $arrayOfDealDetailsDealDetailsItem) {
            // validation for constraint: itemType
            if (!$arrayOfDealDetailsDealDetailsItem instanceof \StructType\DealDetails) {
                throw new \InvalidArgumentException(sprintf('The DealDetails property can only contain items of \StructType\DealDetails, "%s" given', is_object($arrayOfDealDetailsDealDetailsItem) ? get_class($arrayOfDealDetailsDealDetailsItem) : gettype($arrayOfDealDetailsDealDetailsItem)), __LINE__);
            }
        }
        if (is_null($dealDetails) || (is_array($dealDetails) && empty($dealDetails))) {
            unset($this->DealDetails);
        } else {
            $this->DealDetails = $dealDetails;
        }
        return $this;
    }
    /**
     * Add item to DealDetails value
     * @throws \InvalidArgumentException
     * @param \StructType\DealDetails $item
     * @return \ArrayType\ArrayOfDealDetails
     */
    public function addToDealDetails(\StructType\DealDetails $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DealDetails) {
            throw new \InvalidArgumentException(sprintf('The DealDetails property can only contain items of \StructType\DealDetails, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DealDetails[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DealDetails|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DealDetails|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DealDetails|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DealDetails|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DealDetails|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DealDetails
     */
    public function getAttributeName()
    {
        return 'DealDetails';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDealDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
